searchData={"items":[{"type":"module","title":"Doctor","doc":"Doctor is a utility which aims to provide insights into the health of your project's documentation.\nIn addition to be a useful development time tool, Doctor can also be useful during CI/CD and can block\nmerges and releases if the documentation coverage is not up to spec.\n\nDoctor comes with sane defaults out of the box, but if you wish to customize its settings, feel free to\ncreate your own .doctor.exs file.","ref":"Doctor.html"},{"type":"module","title":"Doctor.CLI","doc":"Provides the various CLI task entry points and CLI arg parsing.","ref":"Doctor.CLI.html"},{"type":"function","title":"Doctor.CLI.generate_module_report_list/1","doc":"Given the CLI arguments, run the report on the project,","ref":"Doctor.CLI.html#generate_module_report_list/1"},{"type":"function","title":"Doctor.CLI.generate_single_module_report/2","doc":"Generate a report for a single project module.","ref":"Doctor.CLI.html#generate_single_module_report/2"},{"type":"function","title":"Doctor.CLI.process_module_report_list/2","doc":"Given a list of individual module reports, process each item in the\nlist with the configured reporter and return a pass or fail boolean","ref":"Doctor.CLI.html#process_module_report_list/2"},{"type":"module","title":"Doctor.Config","doc":"This module defines a struct which houses all the\nconfiguration data for Doctor.","ref":"Doctor.Config.html"},{"type":"function","title":"Doctor.Config.config_defaults_as_string/0","doc":"Get the configuration defaults as a string","ref":"Doctor.Config.html#config_defaults_as_string/0"},{"type":"function","title":"Doctor.Config.config_file/0","doc":"Get the configuration file name","ref":"Doctor.Config.html#config_file/0"},{"type":"function","title":"Doctor.Config.moduledoc_required?/1","doc":"Returns true if a specific module should fail validation if it lacks a\nmoduledoc.\"","ref":"Doctor.Config.html#moduledoc_required?/1"},{"type":"function","title":"Doctor.Config.new/1","doc":"Create a new Config struct from a map, keyword list or preexisting Config.","ref":"Doctor.Config.html#new/1"},{"type":"type","title":"Doctor.Config.t/0","doc":"* `:min_module_doc_coverage` - Minimum ratio of @doc vs public functions\n  per module.\n* `:min_overall_doc_coverage` - Minimum ratio of @doc vs public functions\n  across the codebase.\n* `:min_overall_moduledoc_coverage` - Minimum ratio of @moduledoc to modules\n  across the codebase.\n* `:moduledoc_required` - If true, `:min_overall_moduledoc_coverage` is\n  automatically set to 100%. Deprecated.","ref":"Doctor.Config.html#t:t/0"},{"type":"module","title":"Doctor.Docs","doc":"This module defines a struct which houses all the\ndocumentation data for module functions.","ref":"Doctor.Docs.html"},{"type":"function","title":"Doctor.Docs.build/1","doc":"Build the Docs struct from the results of Code.fetch_docs/0","ref":"Doctor.Docs.html#build/1"},{"type":"type","title":"Doctor.Docs.t/0","doc":"","ref":"Doctor.Docs.html#t:t/0"},{"type":"module","title":"Doctor.ModuleInformation","doc":"This module defines a struct which houses all the\ndocumentation data for an entire module.","ref":"Doctor.ModuleInformation.html"},{"type":"function","title":"Doctor.ModuleInformation.build/2","doc":"Breaks down the docs format entry returned from Code.fetch_docs(MODULE)","ref":"Doctor.ModuleInformation.html#build/2"},{"type":"function","title":"Doctor.ModuleInformation.contains_struct_type_spec?/1","doc":"Checks the provided module for a __struct__ function which is injected into the module\nwhenever you use `defstruct`","ref":"Doctor.ModuleInformation.html#contains_struct_type_spec?/1"},{"type":"function","title":"Doctor.ModuleInformation.load_file_ast/1","doc":"Given the provided module, read the file from which the module was generated and\nconvert the file to an AST.","ref":"Doctor.ModuleInformation.html#load_file_ast/1"},{"type":"function","title":"Doctor.ModuleInformation.load_user_defined_functions/1","doc":"Given a ModuleInformation struct with the AST loaded, fetch all of the author defined functions","ref":"Doctor.ModuleInformation.html#load_user_defined_functions/1"},{"type":"type","title":"Doctor.ModuleInformation.t/0","doc":"","ref":"Doctor.ModuleInformation.html#t:t/0"},{"type":"module","title":"Doctor.ModuleReport","doc":"This module exposes a struct which encapsulates all the results for a doctor report. Whether\nthe module has a moduledoc, what the doc coverage is, the number of author defined functions,\nand so on.","ref":"Doctor.ModuleReport.html"},{"type":"function","title":"Doctor.ModuleReport.build/1","doc":"Given a ModuleInformation struct with the necessary fields completed,\nbuild the report.","ref":"Doctor.ModuleReport.html#build/1"},{"type":"type","title":"Doctor.ModuleReport.t/0","doc":"","ref":"Doctor.ModuleReport.html#t:t/0"},{"type":"module","title":"Doctor.ReportUtils","doc":"This module provides some utility functions for use in report generators.","ref":"Doctor.ReportUtils.html"},{"type":"function","title":"Doctor.ReportUtils.calc_overall_doc_coverage/1","doc":"Calculate the overall doc coverage in the codebase","ref":"Doctor.ReportUtils.html#calc_overall_doc_coverage/1"},{"type":"function","title":"Doctor.ReportUtils.calc_overall_moduledoc_coverage/1","doc":"Calculate the ratio of modules which have a moduledoc.","ref":"Doctor.ReportUtils.html#calc_overall_moduledoc_coverage/1"},{"type":"function","title":"Doctor.ReportUtils.calc_overall_spec_coverage/1","doc":"Calculate the overall spec coverage in the codebase","ref":"Doctor.ReportUtils.html#calc_overall_spec_coverage/1"},{"type":"function","title":"Doctor.ReportUtils.count_total_documented_functions/1","doc":"Given a list of module reports, count the total number of documented functions","ref":"Doctor.ReportUtils.html#count_total_documented_functions/1"},{"type":"function","title":"Doctor.ReportUtils.count_total_failed_modules/2","doc":"Given a list of module reports, count the total number of failed modules","ref":"Doctor.ReportUtils.html#count_total_failed_modules/2"},{"type":"function","title":"Doctor.ReportUtils.count_total_functions/1","doc":"Given a list of module reports, count the total number of functions","ref":"Doctor.ReportUtils.html#count_total_functions/1"},{"type":"function","title":"Doctor.ReportUtils.count_total_passed_modules/2","doc":"Given a list of module reports, count the total number of passed modules","ref":"Doctor.ReportUtils.html#count_total_passed_modules/2"},{"type":"function","title":"Doctor.ReportUtils.count_total_speced_functions/1","doc":"Given a list of module reports, count the total number of speced functions","ref":"Doctor.ReportUtils.html#count_total_speced_functions/1"},{"type":"function","title":"Doctor.ReportUtils.doctor_report_errors/2","doc":"Check whether Doctor overall has passed or failed validation","ref":"Doctor.ReportUtils.html#doctor_report_errors/2"},{"type":"function","title":"Doctor.ReportUtils.doctor_report_passed?/2","doc":"Check whether Doctor overall has passed or failed validation","ref":"Doctor.ReportUtils.html#doctor_report_passed?/2"},{"type":"function","title":"Doctor.ReportUtils.module_passed_validation?/2","doc":"Checks whether the provided module passed validation","ref":"Doctor.ReportUtils.html#module_passed_validation?/2"},{"type":"behaviour","title":"Doctor.Reporter","doc":"Defines the behaviour for a reporter","ref":"Doctor.Reporter.html"},{"type":"callback","title":"Doctor.Reporter.generate_report/2","doc":"","ref":"Doctor.Reporter.html#c:generate_report/2"},{"type":"type","title":"Doctor.Reporter.module_reports/0","doc":"","ref":"Doctor.Reporter.html#t:module_reports/0"},{"type":"module","title":"Doctor.Reporters.Full","doc":"This reporter generates a full documentation coverage report and lists\nall the files in the project along with whether they pass or fail.","ref":"Doctor.Reporters.Full.html"},{"type":"function","title":"Doctor.Reporters.Full.generate_report/2","doc":"Generate a full Doctor report and print to STDOUT","ref":"Doctor.Reporters.Full.html#generate_report/2"},{"type":"module","title":"Doctor.Reporters.ModuleExplain","doc":"This module produces a report for a single project module. This\nis useful when you need to figure out exactly why a particular\nmodule failed validation. The only validations that are taken\ninto account during this report are single module validations.\nIn other words, the only thing that is checked are things that\npertain to a single module like:\n  - `min_module_doc_coverage`\n  - `min_module_spec_coverage`\n  - `moduledoc_required`\n  - `exception_moduledoc_required`\n  - `struct_type_spec_required`","ref":"Doctor.Reporters.ModuleExplain.html"},{"type":"function","title":"Doctor.Reporters.ModuleExplain.generate_report/2","doc":"Generate the output for a single module report","ref":"Doctor.Reporters.ModuleExplain.html#generate_report/2"},{"type":"module","title":"Doctor.Reporters.OutputUtils","doc":"This module provides convenience functions for use when generating\nreports","ref":"Doctor.Reporters.OutputUtils.html"},{"type":"function","title":"Doctor.Reporters.OutputUtils.gen_fixed_width_string/3","doc":"Generate a string with a configure amount of width and padding","ref":"Doctor.Reporters.OutputUtils.html#gen_fixed_width_string/3"},{"type":"function","title":"Doctor.Reporters.OutputUtils.generate_table_line/1","doc":"Generate a line in a table with the given width and padding. Expects a\nlist with either a 2 or 3 element tuple.","ref":"Doctor.Reporters.OutputUtils.html#generate_table_line/1"},{"type":"function","title":"Doctor.Reporters.OutputUtils.print_divider/1","doc":"Prints a divider of a given length","ref":"Doctor.Reporters.OutputUtils.html#print_divider/1"},{"type":"function","title":"Doctor.Reporters.OutputUtils.print_error/1","doc":"Prints a string in red","ref":"Doctor.Reporters.OutputUtils.html#print_error/1"},{"type":"function","title":"Doctor.Reporters.OutputUtils.print_pass_or_fail/1","doc":"Prints a checkmark of an X if true of false is provided respectively","ref":"Doctor.Reporters.OutputUtils.html#print_pass_or_fail/1"},{"type":"function","title":"Doctor.Reporters.OutputUtils.print_success/1","doc":"Prints a string in green","ref":"Doctor.Reporters.OutputUtils.html#print_success/1"},{"type":"module","title":"Doctor.Reporters.Short","doc":"This reporter generates a full documentation coverage report and lists\nall the files in the project along with whether they pass or fail.","ref":"Doctor.Reporters.Short.html"},{"type":"function","title":"Doctor.Reporters.Short.generate_report/2","doc":"Generate a short Doctor report and print to STDOUT","ref":"Doctor.Reporters.Short.html#generate_report/2"},{"type":"module","title":"Doctor.Reporters.Summary","doc":"This reporter generates a short summary documentation coverage report\nand lists overall how many modules passed/failed.","ref":"Doctor.Reporters.Summary.html"},{"type":"function","title":"Doctor.Reporters.Summary.generate_report/2","doc":"Generate a short summary Doctor report and print to STDOUT","ref":"Doctor.Reporters.Summary.html#generate_report/2"},{"type":"module","title":"Doctor.Specs","doc":"This module defines a struct which houses all the\ndocumentation data for function specs.","ref":"Doctor.Specs.html"},{"type":"function","title":"Doctor.Specs.build/1","doc":"Build a spec definition for each result from Code.Typespec.fetch_specs/1","ref":"Doctor.Specs.html#build/1"},{"type":"type","title":"Doctor.Specs.t/0","doc":"","ref":"Doctor.Specs.html#t:t/0"},{"type":"task","title":"mix doctor","doc":"Doctor is a command line utility that can be used to ensure that your project\ndocumentation remains healthy. For more in depth documentation on Doctor or to\nfile bug/feature requests, please check out https://github.com/akoutmos/doctor.\n\nThe `mix doctor` command supports the following CLI flags (all of these options\nand more are also configurable from your `.doctor.exs` file). The following CLI\nflags are supported:\n\n```\n--config_file  Provide a relative or absolute path to a `.doctor.exs`\n               file to use during the execution of the mix command.\n\n--full         When generating a Doctor report of your project, use\n               the Doctor.Reporters.Full reporter.\n\n--short        When generating a Doctor report of your project, use\n               the Doctor.Reporters.Short reporter.\n\n--summary      When generating a Doctor report of your project, use\n               the Doctor.Reporters.Summary reporter.\n\n--raise        If any of your modules fails Doctor validation, then\n               raise an error and return a non-zero exit status.\n\n--failed       If set, only the failed modules will be reported. Works with\n               --full and --short options.\n\n--umbrella     By default, in an umbrella project, each app will be\n               evaluated independently against the specified thresholds\n               in your .doctor.exs file. This flag changes that behavior\n               by aggregating the results of all your umbrella apps,\n               and then comparing those results to the configured\n               thresholds.\n```","ref":"Mix.Tasks.Doctor.html"},{"type":"task","title":"mix doctor.explain","doc":"Figuring out why a particular module failed Doctor validation can sometimes\nbe a bit difficult when the relevant information is embedded within a table with\nother validation results.\n\nThe `mix doctor.explain` command has only a single required argument. That argument\nis the name of the module that you wish to get a detailed report of. For example you\ncould run the following from the terminal:\n\n```\n$ mix doctor.explain MyApp.Some.Module\n```\n\nTo generate a report like this:\n\n```\nDoctor file found. Loading configuration.\n\nFunction            @doc  @spec\n-------------------------------\ngenerate_report/2   ✗     ✗\n\nModule Results:\n  Doc Coverage:    0.0%  --> Your config has a 'min_module_doc_coverage' value of 80\n  Spec Coverage:   0.0%\n  Has Module Doc:  ✓\n  Has Struct Spec: N/A\n```\n\nIn addition, the following CLI flags are supported (similarly to the `mix doctor`\ncommand):\n\n```\n--config-file  Provide a relative or absolute path to a `.doctor.exs`\n               file to use during the execution of the mix command.\n\n--raise        If any of your modules fails Doctor validation, then\n               raise an error and return a non-zero exit status.\n```\n\nTo use these command line args you would do something like so:\n\n```\n$ mix doctor.explain --raise --config_file /some/path/to/some/.doctor.exs MyApp.Some.Module\n```\n\nNote that `mix doctor.explain` takes a module name instead of a file path since you can\ndefine multiple modules in a single file.","ref":"Mix.Tasks.Doctor.Explain.html"},{"type":"task","title":"mix doctor.gen.config","doc":"Doctor is a command line utility that can be used to ensure that your project\ndocumentation remains healthy. For more in depth documentation on Doctor or to\nfile bug/feature requests, please check out https://github.com/akoutmos/doctor.\n\nThe `mix doctor.gen.config` command can be used to create a `.doctor.exs` file\nwith the default Doctor settings. The default file contents are:\n\n```\n%Doctor.Config{\n  ignore_modules: [],\n  ignore_paths: [],\n  min_module_doc_coverage: 40,\n  min_module_spec_coverage: 0,\n  min_overall_doc_coverage: 50,\n  min_overall_moduledoc_coverage: 100,\n  min_overall_spec_coverage: 0,\n  exception_moduledoc_required: true,\n  raise: false,\n  reporter: Doctor.Reporters.Full,\n  struct_type_spec_required: true,\n  umbrella: false\n}\n```","ref":"Mix.Tasks.Doctor.Gen.Config.html"},{"type":"function","title":"Mix.Tasks.Doctor.Gen.Config.run/1","doc":"This Mix task generates a .doctor.exs configuration file","ref":"Mix.Tasks.Doctor.Gen.Config.html#run/1"},{"type":"extras","title":"Doctor","doc":"# Doctor\n\n[![Module Version](https://img.shields.io/hexpm/v/doctor.svg?style=for-the-badge)](https://hex.pm/packages/doctor)\n[![Doctor CI](https://img.shields.io/github/actions/workflow/status/akoutmos/doctor/master.yml?label=Build%20Status&style=for-the-badge&branch=master)](https://github.com/akoutmos/doctor/actions)\n[![Coverage Status](https://img.shields.io/coverallsCoverage/github/akoutmos/doctor.svg?branch=master&style=for-the-badge)](https://coveralls.io/github/akoutmos/doctor?branch=master)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg?style=for-the-badge)](https://hexdocs.pm/doctor/)\n[![Total Download](https://img.shields.io/hexpm/dt/doctor.svg?style=for-the-badge)](https://hex.pm/packages/doctor)\n[![License](https://img.shields.io/hexpm/l/doctor.svg?style=for-the-badge)](https://github.com/akoutmos/doctor/blob/master/LICENSE)\n\nEnsure that your documentation is healthy with Doctor! This library contains a mix task that you can run against your\nproject to generate a documentation coverage report. Items which are reported on include: the presence of module docs,\nwhich functions do/don't have docs, which functions do/don't have typespecs, and if your struct modules provide\ntypespecs. You can generate a `.doctor.exs` config file to specify what thresholds are acceptable for your project. If\ndocumentation coverage drops below your specified thresholds, the `mix doctor` task will return a non zero exit status.\n\nThe primary motivation with this tool is to have something simple which can be hooked up into CI to ensure that project\ndocumentation standards are respected and upheld. This is particular useful in a team environment when you want to\nmaintain a minimum threshold for documentation coverage.","ref":"readme.html"},{"type":"extras","title":"Installation - Doctor","doc":"Adding `:doctor` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:doctor, \"~> 0.22.0\", only: :dev}\n  ]\nend\n```\n\nDocumentation can be found at [https://hexdocs.pm/doctor](https://hexdocs.pm/doctor).","ref":"readme.html#installation"},{"type":"extras","title":"Comparison with other tools - Doctor","doc":"There are a few tools in the Elixir ecosystem that overlap slightly in functionality with Doctor. It is useful for\nyou to know how Doctor differs from these tools and some use cases that Doctor serves.\n\n**Credo**\n\n[Credo](https://github.com/rrrene/credo) is a phenomenal library that can be used to perform a wide range of\nstatic analysis checks against your codebase. It can check for lingering `IO.inspect()` statements, it can check for\nunsafe atom conversions, and it can also check that the cyclomatic complexity of control statements is within a\nparticular range to name a few.\n\nThe one area where Doctor and Credo do overlap is that with either tool you have the capability to\nenforce that `@moduledoc` attributes are present in modules. Given that this is the only overlap between the two tools,\nI generally use both in my projects and perform both validations during CI/CD.\n\n**Inch**\n\n[Inch](https://github.com/rrrene/inch_ex) is another great tool written by René Föhring that is specifically\ncatered to analyzing a project's documentation (very much like Doctor). Inch will scan your project's source files and\ncheck for the presence of function documentation and report back to you what grade it thinks your project has earned.\n\nInch does not appear to support checking for function typespecs, returning non-zero status codes when validation fails,\ntuning thresholds via a configuration file, or checking for struct module typespecs. On the other hand, these were\nthings that were important to me personally and so I wrote Doctor to fill that void. In a team context, I find Doctor to\nbe invaluable in ensuring that a project maintains a certain level of documentation by failing CI/CD if certain\nthresholds have not been met.\n\nIf I have misrepresented any of the aforementioned libraries...feel free to open up an issue :).","ref":"readme.html#comparison-with-other-tools"},{"type":"extras","title":"Usage - Doctor","doc":"Doctor comes with 2 mix tasks. One to run the documentation coverage report, and another to generate a `.doctor.exs` config file.\n\nTo run the doctor mix task and generate a report, run: `mix doctor`.\nTo generate a `.doctor.exs` config file with defaults, run: `mix doctor.gen.config`.\nTo get help documentation, run `mix help doctor` and `mix help doctor.gen.config`. The outputs of those help menus can be seen here:\n\nRunning `mix help doctor` yields:\n\n```terminal\n                                   mix doctor\n\nDoctor is a command line utility that can be used to ensure that your project\ndocumentation remains healthy. For more in depth documentation on Doctor or to\nfile bug/feature requests, please check out https://github.com/akoutmos/doctor.\n\nThe mix doctor command supports the following CLI flags (all of these options\nand more are also configurable from your .doctor.exs file). The following CLI\nflags are supported:\n\n    --full       When generating a Doctor report of your project, use\n                 the Doctor.Reporters.Full reporter.\n\n    --short      When generating a Doctor report of your project, use\n                 the Doctor.Reporters.Short reporter.\n\n    --summary    When generating a Doctor report of your project, use\n                 the Doctor.Reporters.Summary reporter.\n\n    --raise      If any of your modules fails Doctor validation, then\n                 raise an error and return a non-zero exit status.\n\n    --failed     If set only the failed modules will be reported. Works with\n                 --full and --short options.\n\n    --umbrella   By default, in an umbrella project, each app will be\n                 evaluated independently against the specified thresholds\n                 in your .doctor.exs file. This flag changes that behavior\n                 by aggregating the results of all your umbrella apps,\n                 and then comparing those results to the configured\n                 thresholds.\n```\n\nRunning `mix help doctor.gen.config` yields:\n\n```terminal\n                             mix doctor.gen.config\n\nDoctor is a command line utility that can be used to ensure that your project\ndocumentation remains healthy. For more in depth documentation on Doctor or to\nfile bug/feature requests, please check out https://github.com/akoutmos/doctor.\n\nThe mix doctor.gen.config command can be used to create a .doctor.exs file with\nthe default Doctor settings. The default file contents are:\n\n    %Doctor.Config{\n      ignore_modules: [],\n      ignore_paths: [],\n      min_module_doc_coverage: 40,\n      min_module_spec_coverage: 0,\n      min_overall_doc_coverage: 50,\n      min_overall_moduledoc_coverage: 100,\n      min_overall_spec_coverage: 0,\n      exception_moduledoc_required: true,\n      raise: false,\n      reporter: Doctor.Reporters.Full,\n      struct_type_spec_required: true,\n      umbrella: false\n    }\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Doctor","doc":"Below is a sample `.doctor.exs` file with some sample values for the various fields:\n\n```elixir\n%Doctor.Config{\n  ignore_modules: [],\n  ignore_paths: [],\n  min_module_doc_coverage: 40,\n  min_module_spec_coverage: 0,\n  min_overall_doc_coverage: 50,\n  min_overall_moduledoc_coverage: 100,\n  min_overall_spec_coverage: 0,\n  exception_moduledoc_required: true,\n  raise: false,\n  reporter: Doctor.Reporters.Full,\n  struct_type_spec_required: true,\n  umbrella: false\n}\n```\n\nFor the reporter field, the following reporters included with Doctor:\n\n- `Doctor.Reporters.Full`\n- `Doctor.Reporters.Short`\n- `Doctor.Reporters.Summary`","ref":"readme.html#configuration"},{"type":"extras","title":"Sample reports - Doctor","doc":"Report created for Doctor itself:\n\n```text\n$ mix doctor\nDoctor file found. Loading configuration.\n---------------------------------------------------------------------------------------------------------------------------------------------------------------------------\nDoc Cov  Spec Cov  Module                                   File\nFunctions  No Docs  No Specs  Module Doc  Struct Spec\n100%     0%        Doctor.CLI                               lib/cli/cli.ex                                            2\n0        2         Yes         N/A\n100%     0%        Doctor.Config                            lib/config.ex                                             3\n0        3         Yes         Yes\n100%     0%        Doctor.Docs                              lib/docs.ex                                               1\n0        1         Yes         Yes\nN/A      N/A       Doctor                                   lib/doctor.ex                                             0\n0        0         Yes         N/A\n100%     100%      Mix.Tasks.Doctor                         lib/mix/tasks/doctor.ex                                   1\n0        0         Yes         N/A\n100%     0%        Mix.Tasks.Doctor.Gen.Config              lib/mix/tasks/doctor.gen.config.ex                        1\n0        1         Yes         N/A\n100%     0%        Doctor.ModuleInformation                 lib/module_information.ex                                 4\n0        4         Yes         Yes\n100%     0%        Doctor.ModuleReport                      lib/module_report.ex                                      1\n0        1         Yes         Yes\n100%     0%        Doctor.ReportUtils                       lib/report_utils.ex                                       9\n0        9         Yes         N/A\nN/A      N/A       Doctor.Reporter                          lib/reporter.ex                                           0\n0        0         Yes         N/A\n100%     0%        Doctor.Reporters.Full                    lib/reporters/full.ex                                     1\n0        1         Yes         N/A\n100%     0%        Doctor.Reporters.OutputUtils             lib/reporters/output_utils.ex                             1\n0        1         Yes         N/A\n100%     0%        Doctor.Reporters.Short                   lib/reporters/short.ex                                    1\n0        1         Yes         N/A\n100%     0%        Doctor.Reporters.Summary                 lib/reporters/summary.ex                                  1\n0        1         Yes         N/A\n100%     0%        Doctor.Specs                             lib/specs.ex                                              1\n0        1         Yes         Yes\n---------------------------------------------------------------------------------------------------------------------------------------------------------------------------\nSummary:\n\nPassed Modules: 15\nFailed Modules: 0\nTotal Doc Coverage: 100.0%\nTotal Spec Coverage: 3.7%\n\nDoctor validation has passed!\n```\n\nReport created for Phoenix:\n\n```text\n$ mix doctor\nDoctor file not found. Using defaults.\n--------------------------------------------------------------------------------------------------------------------------------------------------------------------------\nDoc Cov  Spec Cov  Module                                   File                                                                  Functions  No Docs  No Specs  Module Doc\n100%     0%        Mix.Phoenix                              lib/mix/phoenix.ex                                                    18         0        18        YES\n0%       0%        Mix.Phoenix.Context                      lib/mix/phoenix/context.ex                                            6          6        6         YES\n63%      0%        Mix.Phoenix.Schema                       lib/mix/phoenix/schema.ex                                             8          3        8         YES\n100%     0%        Mix.Tasks.Compile.Phoenix                lib/mix/tasks/compile.phoenix.ex                                      2          0        2         YES\n100%     0%        Mix.Tasks.Phx.Digest.Clean               lib/mix/tasks/phx.digest.clean.ex                                     1          0        1         YES\n100%     0%        Mix.Tasks.Phx.Digest                     lib/mix/tasks/phx.digest.ex                                           1          0        1         YES\n100%     0%        Mix.Tasks.Phx                            lib/mix/tasks/phx.ex                                                  1          0        1         YES\n100%     0%        Mix.Tasks.Phx.Gen.Cert                   lib/mix/tasks/phx.gen.cert.ex                                         2          0        2         YES\n100%     0%        Mix.Tasks.Phx.Gen.Channel                lib/mix/tasks/phx.gen.channel.ex                                      1          0        1         YES\n86%      14%       Mix.Tasks.Phx.Gen.Context                lib/mix/tasks/phx.gen.context.ex                                      7          1        6         YES\n100%     17%       Mix.Tasks.Phx.Gen.Embedded               lib/mix/tasks/phx.gen.embedded.ex                                     6          0        5         YES\n100%     0%        Mix.Tasks.Phx.Gen.Html                   lib/mix/tasks/phx.gen.html.ex                                         4          0        4         YES\n100%     0%        Mix.Tasks.Phx.Gen.Json                   lib/mix/tasks/phx.gen.json.ex                                         4          0        4         YES\n100%     0%        Mix.Tasks.Phx.Gen.Presence               lib/mix/tasks/phx.gen.presence.ex                                     1          0        1         YES\n100%     14%       Mix.Tasks.Phx.Gen.Schema                 lib/mix/tasks/phx.gen.schema.ex                                       7          0        6         YES\n100%     0%        Mix.Tasks.Phx.Gen.Secret                 lib/mix/tasks/phx.gen.secret.ex                                       1          0        1         YES\n100%     0%        Mix.Tasks.Phx.Routes                     lib/mix/tasks/phx.routes.ex                                           1          0        1         YES\n100%     0%        Mix.Tasks.Phx.Server                     lib/mix/tasks/phx.server.ex                                           1          0        1         YES\n100%     0%        Phoenix                                  lib/phoenix.ex                                                        3          0        3         YES\n100%     17%       Phoenix.Channel                          lib/phoenix/channel.ex                                                12         0        10        YES\n100%     18%       Phoenix.Channel.Server                   lib/phoenix/channel/server.ex                                         17         0        14        YES\n100%     0%        Phoenix.CodeReloader                     lib/phoenix/code_reloader.ex                                          2          0        2         YES\n40%      0%        Phoenix.CodeReloader.Proxy               lib/phoenix/code_reloader/proxy.ex                                    5          3        5         YES\n33%      0%        Phoenix.CodeReloader.Server              lib/phoenix/code_reloader/server.ex                                   6          4        6         YES\n88%      25%       Phoenix.Config                           lib/phoenix/config.ex                                                 8          1        6         YES\n100%     52%       Phoenix.Controller                       lib/phoenix/controller.ex                                             42         0        20        YES\n100%     0%        Phoenix.Controller.Pipeline              lib/phoenix/controller/pipeline.ex                                    6          0        6         YES\n100%     100%      Phoenix.Digester                         lib/phoenix/digester.ex                                               2          0        0         YES\n100%     0%        Phoenix.Endpoint                         lib/phoenix/endpoint.ex                                               25         0        25        YES\n100%     0%        Phoenix.Endpoint.Cowboy2Adapter          lib/phoenix/endpoint/cowboy2_adapter.ex                               3          0        3         YES\n0%       0%        Phoenix.Endpoint.Cowboy2Handler          lib/phoenix/endpoint/cowboy2_handler.ex                               5          5        5         YES\n100%     0%        Phoenix.Endpoint.CowboyAdapter           lib/phoenix/endpoint/cowboy_adapter.ex                                2          0        2         YES\n0%       0%        Phoenix.Endpoint.CowboyWebSocket         lib/phoenix/endpoint/cowboy_websocket.ex                              8          8        8         YES\n100%     0%        Phoenix.Endpoint.RenderErrors            lib/phoenix/endpoint/render_errors.ex                                 3          0        3         YES\n93%      0%        Phoenix.Endpoint.Supervisor              lib/phoenix/endpoint/supervisor.ex                                    15         1        15        YES\n0%       0%        Phoenix.Endpoint.Watcher                 lib/phoenix/endpoint/watcher.ex                                       2          2        2         YES\nNA       NA        Plug.Exception.Phoenix.ActionClauseErro  lib/phoenix/exceptions.ex                                             0          0        0         NO\nNA       NA        Phoenix.NotAcceptableError               lib/phoenix/exceptions.ex                                             0          0        0         YES\n100%     0%        Phoenix.MissingParamError                lib/phoenix/exceptions.ex                                             1          0        1         YES\n0%       0%        Phoenix.ActionClauseError                lib/phoenix/exceptions.ex                                             2          2        2         NO\n60%      0%        Phoenix.Logger                           lib/phoenix/logger.ex                                                 5          2        5         YES\n83%      100%      Phoenix.Naming                           lib/phoenix/naming.ex                                                 6          1        0         YES\nNA       NA        Phoenix.Param.Map                        lib/phoenix/param.ex                                                  0          0        0         NO\nNA       NA        Phoenix.Param.Integer                    lib/phoenix/param.ex                                                  0          0        0         NO\nNA       NA        Phoenix.Param.BitString                  lib/phoenix/param.ex                                                  0          0        0         NO\nNA       NA        Phoenix.Param.Atom                       lib/phoenix/param.ex                                                  0          0        0         NO\nNA       NA        Phoenix.Param.Any                        lib/phoenix/param.ex                                                  0          0        0         NO\n0%       0%        Phoenix.Param                            lib/phoenix/param.ex                                                  1          1        1         YES\n100%     0%        Phoenix.Presence                         lib/phoenix/presence.ex                                               17         0        17        YES\nNA       NA        Phoenix.Router.NoRouteError              lib/phoenix/router.ex                                                 0          0        0         YES\n100%     0%        Phoenix.Router                           lib/phoenix/router.ex                                                 11         0        11        YES\n100%     0%        Phoenix.Router.ConsoleFormatter          lib/phoenix/router/console_formatter.ex                               1          0        1         YES\n95%      0%        Phoenix.Router.Helpers                   lib/phoenix/router/helpers.ex                                         20         1        20        YES\n100%     0%        Phoenix.Router.Resource                  lib/phoenix/router/resource.ex                                        1          0        1         YES\n100%     20%       Phoenix.Router.Route                     lib/phoenix/router/route.ex                                           5          0        4         YES\n100%     0%        Phoenix.Router.Scope                     lib/phoenix/router/scope.ex                                           9          0        9         YES\nNA       NA        Phoenix.Socket.InvalidMessageError       lib/phoenix/socket.ex                                                 0          0        0         YES\n57%      0%        Phoenix.Socket                           lib/phoenix/socket.ex                                                 14         6        14        YES\nNA       NA        Phoenix.Socket.Reply                     lib/phoenix/socket/message.ex                                         0          0        0         YES\n100%     0%        Phoenix.Socket.Message                   lib/phoenix/socket/message.ex                                         1          0        1         YES\nNA       NA        Phoenix.Socket.Broadcast                 lib/phoenix/socket/message.ex                                         0          0        0         YES\n50%      0%        Phoenix.Socket.PoolSupervisor            lib/phoenix/socket/pool_supervisor.ex                                 4          2        4         YES\nNA       NA        Phoenix.Socket.Serializer                lib/phoenix/socket/serializer.ex                                      0          0        0         YES\n0%       0%        Phoenix.Socket.V1.JSONSerializer         lib/phoenix/socket/serializers/v1_json_serializer.ex                  3          3        3         YES\n0%       0%        Phoenix.Socket.V2.JSONSerializer         lib/phoenix/socket/serializers/v2_json_serializer.ex                  3          3        3         YES\n100%     0%        Phoenix.Socket.Transport                 lib/phoenix/socket/transport.ex                                       6          0        6         YES\nNA       NA        Phoenix.Template.UndefinedError          lib/phoenix/template.ex                                               0          0        0         YES\n100%     45%       Phoenix.Template                         lib/phoenix/template.ex                                               11         0        6         YES\n0%       0%        Phoenix.Template.EExEngine               lib/phoenix/template/eex_engine.ex                                    1          1        1         YES\nNA       NA        Phoenix.Template.Engine                  lib/phoenix/template/engine.ex                                        0          0        0         YES\n0%       0%        Phoenix.Template.ExsEngine               lib/phoenix/template/exs_engine.ex                                    1          1        1         YES\nNA       NA        Phoenix.ChannelTest.NoopSerializer       lib/phoenix/test/channel_test.ex                                      0          0        0         YES\n100%     11%       Phoenix.ChannelTest                      lib/phoenix/test/channel_test.ex                                      19         0        17        YES\n100%     94%       Phoenix.ConnTest                         lib/phoenix/test/conn_test.ex                                         17         0        1         YES\n100%     0%        Phoenix.Token                            lib/phoenix/token.ex                                                  2          0        2         YES\n67%      0%        Phoenix.Transports.LongPoll              lib/phoenix/transports/long_poll.ex                                   3          1        3         YES\n50%      0%        Phoenix.Transports.LongPoll.Server       lib/phoenix/transports/long_poll_server.ex                            4          2        4         YES\n0%       0%        Phoenix.Transports.WebSocket             lib/phoenix/transports/websocket.ex                                   2          2        2         YES\n100%     0%        Phoenix.View                             lib/phoenix/view.ex                                                   9          0        9         YES\n--------------------------------------------------------------------------------------------------------------------------------------------------------------------------\nSummary:\n\nPassed Modules: 72\nFailed Modules: 7\nTotal Doc Coverage: 85.1%\nTotal Spec Coverage: 15.3%\n\nDoctor validation has passed!\n```","ref":"readme.html#sample-reports"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.22.0] - 2024-10-30","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"- Fix deprecated Elixir `Logger.warn()` to `Logger.warning()`.\n- Changed minimum Elixir version to 1.14\n\n## [0.21.0] - 2022-11-19","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Recognize protocol implementations\n\n## [0.20.0] - 2022-10-11","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Recognize `@opaque` struct typespecs.\n\n## [0.19.0] - 2022-7-19","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- `mix doctor.explain` now works in umbrella projects\n- Properly measure documentation coverage in nested modules\n- Properly measure documentation with `__using__`\n- Fix `@moduledoc` detection for older elixir versions\n\n## [0.18.0] - 2021-5-27\n\n- @doc false assumes no explicit spec and does not count against results\n- Support for using macro (thanks to @pnezis)\n- No reporting of missing docs for exception modules (thanks to @pnezis)\n\n## [0.17.0] - 2021-1-11\n\n- Bumped up the Elixir version due to use of Mix.Task.recursing/0\n\n## [0.16.0] - 2020-12-27\n\n- Fixed spec coverage bug\n- Added ability to filter modules using Regex\n\n## [0.15.0] - 2020-6-23","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Added `mix doctor.explain` command so that it is easier to debug why a particular module is failing validation","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Modules with behaviours that are aliased were not being counted properly\n\n## [0.14.0] - 2020-3-19","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Additional configuration option struct_type_spec_required that checks for struct module type specs\n\n## [0.13.0] - 2020-5-20","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed spec coverage for behavior callbacks\n\n## [0.12.0] - 2020-3-19","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Ability to aggregate umbrella results into one report\n- Ability to pass custom path to config file\n- CLI docs via `mix help doctor` and `mix help doctor.gen.config`\n\n## [0.11.0] - 2020-1-29","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ability to pass in a file name as a string for ignore_paths\n\n## [0.10.0] - 2019-11-20","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ability to raise from Mix when an error is encountered\n\n## [0.9.0] - 2019-11-11","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- .doctor.exs file not found at root of umbrella project\n\n## [0.8.0] - 2019-6-20","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed Decimal math when module contains no doc coverage\n\n## [0.7.0] - 2019-6-10","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Travis CI and tests","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Incorrect reporting on failed modules\n\n## [0.6.0] - 2019-6-5","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Short reporter","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Incorrect spec coverage\n\n## [0.5.0] - 2019-6-2","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Fixed counting issue when there are multiple modules in a single file\n- Changed reporters around to be more DRY and share report calculation functionality\n- Added tests for Doctor reporting functionality\n\n## [0.4.0] - 2019-1-23","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Loaded application vs starting the application to avoid Ecto errors connecting to DB during Doctor validation\n\n## [0.3.0] - 2018-11-30","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies and fixed depreciation warning\n\n## [0.2.0] - 2018-11-30","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Umbrella project exit status code\n\n## [0.1.0] - 2018-10-04","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release of Doctor.","ref":"changelog.html#added"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}